(*
Programm gibt vom aktuellen Verzeichnis
die ausfhrbaren Dateien *.exe *.com *.bat
sortiert aus
*)

program direxe;
uses crt,dos;
type textfeld = array[1..200] of string[15];
     sortiertyp = string;
var datei:textfeld;
    fileblock:searchrec;
    i,j,max,x,y,maxy,l:integer;
    aktverz,neuverz,dirverz,s:string;


procedure hilfe;
begin
  writeln('DIREXE written by Manfred Mayer');
  writeln('Programm gibt alle ausfhrbaren Dateien (BAT,COM,EXE)');
  writeln('im gewhlten Verzeichnis aus.');
  writeln;
  writeln('Usage: "direxe [Directory]" ');
  writeln;
  halt;
end;


procedure enter;
begin
  write('Enter quetschen! ');
  readln;
end;


procedure lesen(erw:string);
begin
  findfirst(erw,$3F,fileblock);
  while doserror=0 do
  begin
    with fileblock do
    begin
      i:=i+1;
      if i>200 then
      begin
        writeln('Tut leid, mit so vielen Dateien hab ich nicht gerechnet !!!');
        halt;
      end;
      datei[i]:=name;
    end;
    findnext(fileblock);
  end;
end;


procedure sortieren(bis:integer;
                    unsortiert:textfeld;
                    var sortiert:textfeld);
var dummy:sortiertyp;
    fert:boolean;
    lauf1,lauf2:integer;
begin
  for lauf1:=1 to bis-1 do
  begin
    sortiert[lauf1]:=unsortiert[lauf1];
  end;
  lauf1:=bis-1;
  repeat
    lauf1:=lauf1-1;
    fert:=true;
    for lauf2:=1 to bis-1 do
    begin
      if sortiert[lauf2] > sortiert[lauf2+1] then
      begin
        dummy:=sortiert[lauf2];
        sortiert[lauf2]:=sortiert[lauf2+1];
        sortiert[lauf2+1]:=dummy;
        fert:=false;
      end;
    end;
  until fert or (lauf1=1);
end;


procedure ausgeben;
begin
  clrscr;
  gotoxy(1,1);
  write('Ausfhrbare Dateien im Verzeichnis "',dirverz,'" :');
  x:=1;y:=2;
  for i:=1 to max do
  begin
    y:=y+1;if y=23 then
    begin
      y:=3;
      x:=x+20;
      if x=81 then enter;
    end;
    gotoxy(x,y);
    l:=length(datei[i]);
    write( copy(datei[i],1,l-4),copy('         ',1,13-l),copy(datei[i],l-2,3));
  end;
end;


procedure checkpara(par1:string);
var gef:boolean;
begin
  if ((par1='/?') or (par1='?')) then hilfe;
  dirverz:=par1;
  getdir(0,aktverz);
(*$I-*)
  chdir(dirverz);
(*$I+*)
  gef:=ioresult=0;
  getdir(0,dirverz);
  chdir(aktverz);
  if not gef then begin write('Dir nicht vorhanden !!');writeln;halt;end;
  if copy(dirverz,length(dirverz),1) = '\' then dirverz:=copy(dirverz,1,length(dirverz)-1);
end;



(* Hauptprogramm *)
begin
  if paramcount=0 then
  begin
    getdir(0,dirverz);
    aktverz:=dirverz;
    if copy(dirverz,length(dirverz),1) = '\' then dirverz:=copy(dirverz,1,length(dirverz)-1);
  end;
  if paramcount>=1 then checkpara(paramstr(1));
  i:=0;
  lesen(dirverz+'\*.exe');
  lesen(dirverz+'\*.com');
  lesen(dirverz+'\*.bat');
  max:=i;
  sortieren(max,datei,datei);
  ausgeben;
  if max > 20 then gotoxy(1,24) else writeln;
end.
