(*
Kurvenschreiber fr Funktionen f(x)
Bitte im Listing Funktion und Definitionsmenge eingeben !!!
*)

{$N+}
program funktionsprogramm;
uses crt,dos,graph;

const anz = 14;
      xxnull = 250;yynull = 250;
      xxmax = 250 ; yymax = 250;
      bildschirm = lightgray;
      achsenf = blue;
      fenster = green;
      kurve = red;
      schrift = blue;
type feld = array[1..anz] of real;
var xb,yb,stx,sty:feld;
    reg:registers;
    ch:char;
    button,defi,defialt,defineu,mausok:boolean;
    xmax,ymax:string;
    j,mx,my,zx,zy:integer;
    i,x,y,hx,hy:double;


procedure funktion(var defi:boolean);
var d1,d2,d3:boolean;
begin
{ *********** Hier Definitionsmengen eingeben ********** }
{ ********** Welche Werte darf x nicht annehmen ******** }

  d1:= x=0;
  d2:= false;
  d3:= false;

  defi:=not (d1 or d2 or d3);if not defi then exit;

{ ************** Hier Funktion eingeben **************** }
{ ******************* y := f(x) ; ********************** }

  y := (1/(cos(x))) ;

end;



procedure initmaus;
begin
  write('Initialisiere GeniusMaus ... ');
  reg.AX:=0;
  reg.BX:=0;
  reg.CX:=0;
  reg.DX:=0;
  intr(51,reg);
  mausok:= reg.AX<>0;
  if mausok then writeln(' erfolgreich .') else writeln(' nicht vorhanden!!!');
  reg.AX:=1;
  reg.BX:=0;
  reg.CX:=0;
  reg.DX:=0;
  intr(51,reg);
end;


procedure init;
var karte,modus:integer;
begin
  karte:=detect;
  modus:=detect;
  initgraph(karte,modus,'');
  mx:=8;my:=8;
  initmaus;

  xb[ 1] :=     0.005 ; yb[ 1] :=     0.005 ;
  xb[ 2] :=     0.01  ; yb[ 2] :=     0.01  ;
  xb[ 3] :=     0.05  ; yb[ 3] :=     0.05  ;
  xb[ 4] :=     0.1   ; yb[ 4] :=     0.1   ;
  xb[ 5] :=     0.5   ; yb[ 5] :=     0.5   ;
  xb[ 6] :=     1     ; yb[ 6] :=     1     ;
  xb[ 7] :=     5     ; yb[ 7] :=     5     ;
  xb[ 8] :=    10     ; yb[ 8] :=    10     ;
  xb[ 9] :=    50     ; yb[ 9] :=    50     ;
  xb[10] :=   100     ; yb[10] :=   100     ;
  xb[11] :=   500     ; yb[11] :=   500     ;
  xb[12] :=  1000     ; yb[12] :=  1000     ;
  xb[13] :=  5000     ; yb[13] :=  5000     ;
  xb[14] := 10000     ; yb[14] := 10000     ;

end;


procedure maus(var x,y:integer;
               var button:boolean);
begin
  reg.AX:=3;
  reg.BX:=0;
  reg.CX:=0;
  reg.DX:=0;
  intr(51,reg);
  hx:=reg.CX;
  hy:=reg.DX;
  if ((hx > 1000) or (hy > 1000)) then begin hx:=100;hy:=100;end;
  x:=round(hx);
  y:=round(hy);
  button:=reg.BX<>0;
end;

procedure koords;
var xx,yy:real;
    xxx,yyy:string;
    mausx,mausy:integer;
begin
  maus(mausx,mausy,button);
  setcolor(bildschirm);
  bar(xxnull+xxmax+3,85,xxnull+xxmax+140,115);
  xx:=(mausx-xxnull)*(xb[mx]/xxmax);
  yy:=-(mausy-yynull)*(yb[my]/yymax);
  str(xx:12:5,xxx);
  str(yy:12:5,yyy);
  setcolor(schrift);
  outtextxy(xxnull+xxmax+5,90,'x='+xxx);
  outtextxy(xxnull+xxmax+5,100,'y='+yyy);
end;


procedure anleitung;
begin
  clrscr;
  writeln;
  writeln ('    Funktionszeichenprogramm');
  writeln;
  writeln;
  writeln ('* Mit diesem Programm knnen Sie y(x) - Funktionen');
  writeln ('  zeichnen lassen.');
  writeln;
  writeln ('* Zuerst die Funktion und die Definitionsmenge');
  writeln ('  im Listing des Programms eingeben !!!');
  writeln;
  writeln ('* Mit <SPACE> wird Funktion gezeichnet. (<0>=Abbruch)');
  writeln ('* Mit <ESC> wird das Programm beendet.');
  writeln ('* Mit den Cursortasten kann man den Mastab whlen.');
  writeln ('* Xmax und Ymax zeigen den Mastab, d.h. die Lnge');
  writeln ('  der Achsen an.');
  writeln ('* Maus-X und Maus-Y zeigen die Koordinaten eines Punktes');
  writeln ('  der Funktion an, bei dem die Maus gerade steht.');
  writeln;
  initmaus;
  writeln;
  write ('Haben Sie die Funktion schon eingegeben ??? (j/n) ');
  repeat
    ch:=readkey;
    ch:=upcase(ch);
    if ch='N' then halt;
  until ch='J';
end;


procedure achsen;
begin
  clrscr;
  setbkcolor(bildschirm);
  setcolor(fenster);
  rectangle(xxnull-xxmax,yynull-yymax,xxnull+xxmax,yynull+yymax);
  setcolor(achsenf);
  line(xxnull,yynull-yymax,xxnull,yynull+yymax);
  line(xxnull-xxmax,yynull,xxnull+xxmax,yynull);
  setcolor(schrift);
  outtextxy(xxnull+xxmax+5,160,'<ESC> Ende');
  outtextxy(xxnull+xxmax+5,170,'<SPACE> zeichnen');
  outtextxy(xxnull+xxmax+5,180,'<CURSOR> Masstab');
  str(xb[mx]:10:3,xmax);xmax:='Xmax= '+xmax;
  str(yb[my]:10:3,ymax);ymax:='Ymax= '+ymax;
  outtextxy(xxnull+xxmax+5,10,xmax);
  outtextxy(xxnull+xxmax+5,20,ymax);
end;


procedure zeichnen;
begin
  setcolor(kurve);
  i:=-(xb[mx])-(xb[mx]/(2*xxmax));
  defialt:=false;
  repeat
    repeat
      i:=i+(xb[mx]/(2*xxmax));
      x:=i;
      funktion(defi);
      defineu:=defi and (y>=-yb[my]) and (y<=yb[my]);
      if defineu then
      begin
        zx:=round(xxnull+(x*xxmax/xb[mx]));
        zy:=round(yynull-(y*yymax/yb[my]));
        if defialt then
          lineto (zx,zy)
        else begin
          moveto(zx,zy);
          putpixel(zx,zy,kurve);
        end;
      end;
      defialt:=defineu;
    until keypressed or (x>xb[mx]);
    if x>xb[mx] then exit;
    ch:=readkey;
    if ch='0' then exit;
  until 1=2;
end;


(* Hauptprogramm *)
begin
  anleitung;
  init;
  achsen;
  repeat
    repeat
      if mausok then koords;
      delay(400);
    until keypressed;
    ch:=readkey;
    if ch=' ' then begin achsen;zeichnen;end;
    if ch=chr(0) then
    begin
      ch:=readkey;
      case ch of
        chr(72):begin my:=my+1;if my>anz then my:=anz;achsen;end;
        chr(80):begin my:=my-1;if my=0 then my:=1;achsen;end;
        chr(77):begin mx:=mx+1;if mx>anz then mx:=anz;achsen;end;
        chr(75):begin mx:=mx-1;if mx=0 then mx:=1;achsen;end;
      end;
    end;
  until ch=chr(27);
  closegraph;
  clrscr;
end.
