Hier sind einige Hilfestellungen zu Turbo-Pascal enthalten:


Wenn Sie Teile von dieser Datei in Ihr Programm kopieren wollen:

1) Ctrl+K+B....Blockanfang
2) Ctrl+K+K....Blockende
3) Ctrl+K+W....Block in Datei speichern ('CLIP.PAS')
4) Ihr Programm laden
5) Ctrl+K+R....Block von Datei laden ('CLIP.PAS')

Weitere Befehle:

   Ctrl+K+C....Block kopieren
   Ctrl+K+V....Block verschieben
   Ctrl+K+Y....Block lschen
   Ctrl+K+H....Markierung lschen

   Ctrl+Q+F....String suchen

******************************************************************

Allgemeine Infos:

Der Bildschirm ist 80 Zeichen breit und 25 Zeilen hoch
(d.h.: bei gotoxy(1,26) rollt Bildschirm weiter)

******************************************************************

Errorschutz wenn man statt einer Integerzahl einen String eingibt:

program Programm;
uses crt;
var a:integer;

procedure int(var zahl:integer);
var cx,cy,err:integer;
    st:string;
begin
  cx:=wherex;
  cy:=wherey;
  err:=1;
  repeat
    gotoxy(cx,cy);
    clreol;
    readln(st);
    val(st,zahl,err);
  until err=0;
end;

begin
write('Ganze Zahl: ');
(* statt readln(a) *)
int(a);
end.

******************************************************************

Umwandlung von Hex-Zahl auf Dezimalzahl

function hex2dec(hexzahl:string):longint;
var lauf,fakt:longint;
    temp:real;
begin
  temp:=0;
  for lauf:=1 to length(hexzahl) do hexzahl[lauf]:=upcase(hexzahl[lauf]);
  for lauf:=1 to length(hexzahl) do begin
    fakt:=ord(hexzahl[length(hexzahl)-lauf+1])-55;
    if fakt<10 then fakt:=ord(hexzahl[length(hexzahl)-lauf+1])-48;
    temp:=temp+(fakt*exp((lauf-1)*ln(16)));
  end;
  hex2dec:=trunc(temp);
end;

******************************************************************

Abfrage: sind alle Eingaben korrekt ?

program Programm;
uses crt;
var a,b:integer;
      k:boolean;

procedure korrekt;
var ch:char;
begin
  repeat
    write('Alle Eingaben korrekt (J/N) ? ');
    readln(ch);
    ch:=upcase(ch);
  until ((ch='J') or (ch='N'));
  if ch='J' then k:=true else k:=false;
end;

begin
  repeat
    write('1.Zahl: ');
    readln(a);
    write('2.Zahl: ');
    readln(b);
    korrekt;
  until k;
end.

******************************************************************

Taste quetschen:

procedure taste;
begin
  writeln('Drcken Sie eine Taste');
  repeat until keypressed;
end;

******************************************************************

Datei laden:

var datei:text;
    name:string;
    gef:boolean;

repeat
  write('Name der Datei: ');
  readln(name);
  (*$I- *)
  assign(datei,name);
  reset(datei);   (*lesen*)
  rewrite(datei); (*schreiben*)
  append(datei);  (*anfgen*)
  (*$I+ *)
  gef:=ioresult=0;
  if not gef then writeln('Datei nicht gefunden!!');
until gef;

******************************************************************

Schaun ob Datei schon existiert:

uses crt,dos;
var name:string;
    fileblock:searchrec;
begin
  write('Datei: ');
  readln(name);
  findfirst(name,$3F,fileblock);
  if doserror=0 then writeln('Datei existiert');
  if doserror<>0 then writeln('Datei nicht gefunden');
end.

******************************************************************

Guter und schlechter Ton: { Aufruf: ton(true); oder ton(false); }

procedure ton(gut:boolean);
begin
  if gut then
  begin
    sound(262);delay(100);
    sound(330);delay(100);
    sound(392);delay(100);
    sound(523);delay(150);
    nosound; *)
  end;
  if not gut then
  begin
    sound(523);delay(50);
    sound(392);delay(50);
    sound(330);delay(50);
    sound(262);delay(100);
    nosound;
  end;
end;

******************************************************************

Sortieren von Daten: Aufruf sortieren (AnzahlElemente,Feldvar,Feldvar)

** Hauptprogramm: **
type textfeld = array[1..200] of string[15];   oder integer,real,...
     sortiertyp = string;                      oder integer,real,...
var Liste:textfeld;

procedure sortieren(bis:integer;
                    unsortiert:textfeld;
                    var sortiert:textfeld);
var dummy:sortiertyp;
    fert:boolean;
    lauf1,lauf2:integer;
begin
  for lauf1:=1 to bis do
  begin
    sortiert[lauf1]:=unsortiert[lauf1];
  end;
  lauf1:=bis;
  repeat
    lauf1:=lauf1-1;
    fert:=true;
    for lauf2:=1 to bis do
    begin
      if sortiert[lauf2] > sortiert[lauf2+1] then
      begin
        dummy:=sortiert[lauf2];
        sortiert[lauf2]:=sortiert[lauf2+1];
        sortiert[lauf2+1]:=dummy;
        fert:=false;
      end;
    end;
  until fert or (lauf1=1);
end;
