(*
Programm liefert Tastencode der gedrckten Taste
*)

program tastcode;
uses crt,dos;
var taste,umschalt:word;
    ch:char;


function bioskey(f:byte):word;
var reg:registers;
begin
  reg.AH:=f;
  intr($16,reg);
  case f of
    0:bioskey:=reg.ax;
    1:if (reg.flags and $0040) = $0040 then bioskey:=0 else bioskey:=1;
    2:bioskey:=reg.AL;
  end;
end;

type str4=string[4];

function hex(i:word;l:integer):str4;
const hexziffer:string[16]='0123456789ABCDEF';
begin
  if l>0 then hex:=hex(i SHR 4,l-1)+hexziffer[i and $F+1] else hex:='';
end;

procedure status(umschalt,maske:word;erklaerung:string);
begin
  if (umschalt and maske) <> 0 then write(erklaerung);
end;

procedure taste_bioskey;
begin
  writeln('Taste einlesen, Ende mit <ESC>');
  repeat
    while bioskey(1)=0 do;
    taste:=bioskey(0);
    umschalt:=bioskey(2);
    write('Bioskey(0): ',hex(taste,4));
    write(', Scan-Code: ',hex(hi(taste),2));
    taste:=lo(taste);
    write(', ASCII: ',hex(taste,2),', ');
    if taste in [ord(' ')..254] then write('''',chr(taste),''' ');

    status(umschalt,$80,'Ins ');
    status(umschalt,$40,'CapsLock ');
    status(umschalt,$20,'NumLock ');
    status(umschalt,$10,'ScrollLock ');
    status(umschalt,$08,'Alt ');
    status(umschalt,$04,'Ctrl ');
    status(umschalt,$02,'Shift(links) ');
    status(umschalt,$01,'Shift(rechts) ');
    writeln;
  until taste=27;
end;

procedure taste_readkey;
var null:boolean;
begin
  writeln('Taste einlesen, Ende mit <ESC>');
  repeat
    null:=false;
    ch:=readkey;
    if ch=chr(0) then begin ch:=readkey;null:=true;end;
    if null then writeln('Taste: ',ch,'  Code: 0 und ',ord(ch));
    if not null then writeln('Taste: ',ch,'  Code: ',ord(ch));
  until ch=chr(27);
end;


begin
  clrscr;
  writeln('Tastaturcodes einlesen: ');
  write('Mit readkey (r) oder mit bioskey (b) ? ');
  repeat
    ch:=readkey;
    ch:=upcase(ch);
    case ch of
      'R':begin writeln(ch);taste_readkey;halt;end;
      'B':begin writeln(ch);taste_bioskey;halt;end;
    end;
  until 1=2;
end.
