(*
Programm fr Informationen ber Batch-Dateien
es werden vom gewhlten Verzeichnis alle Batch-Dateien
sowie deren zweite Zeile ausgegeben
*)

program batch;
uses crt,dos;
type textfeld = array[1..200] of string[15];
     sortiertyp = string;
var datei:textfeld;
    d:text;
    fileblock:searchrec;
    i,j,max,x,y,maxy,l:integer;
    zeile,aktverz,neuverz,dirverz,s:string;


procedure hilfe;
begin
  writeln('BATCH written by Manfred Mayer');
  writeln('Programm gibt Liste der Batch-Dateien (*.BAT)');
  writeln('plus deren zweite Zeile im gewhlten Verzeichnis aus.');
  writeln;
  writeln('Usage: "batch [Directory]" ');
  writeln;
  writeln('Beispiel: Inhalt der Datei tp.bat :');
  writeln('@echo off');
  writeln('rem Turbo Pascal (30 Buchstaben Kommentar)');
  writeln('c:');
  writeln('cd c:\tp\prog');
  writeln('c:\tp70\bin\turbo');
  writeln;
  halt;
end;


procedure enter;
begin
  write('Enter quetschen! ');
  readln;
end;


procedure lesen(erw:string);
begin
  findfirst(erw,$3F,fileblock);
  while doserror=0 do
  begin
    with fileblock do
    begin
      i:=i+1;
      if i>200 then
      begin
        writeln('Tut leid, mit so vielen Dateien hab ich nicht gerechnet !!!');
        halt;
      end;
      datei[i]:=name;
    end;
    findnext(fileblock);
  end;
end;


procedure sortieren(bis:integer;
                    unsortiert:textfeld;
                    var sortiert:textfeld);
var dummy:sortiertyp;
    fert:boolean;
    lauf1,lauf2:integer;
begin
  for lauf1:=1 to bis-1 do
  begin
    sortiert[lauf1]:=unsortiert[lauf1];
  end;
  lauf1:=bis-1;
  repeat
    lauf1:=lauf1-1;
    fert:=true;
    for lauf2:=1 to bis-1 do
    begin
      if sortiert[lauf2] > sortiert[lauf2+1] then
      begin
        dummy:=sortiert[lauf2];
        sortiert[lauf2]:=sortiert[lauf2+1];
        sortiert[lauf2+1]:=dummy;
        fert:=false;
      end;
    end;
  until fert or (lauf1=1);
end;


procedure ausgeben;
{
123456789a123456789b123456789c123456789d123456789e123456789f123456789g123456789h
BATCHPR1 Kommentar zum 1. BatchProgramm  BATCHPR2 Kommentar zum 2. BatchProgramm
}
begin
  clrscr;
  gotoxy(1,1);
  write('Folgende Batch-Dateien knnen aufgerufen werden: ');
  y:=2;
  x:=1;
  for i:=1 to max do
  begin
    y:=y+1;
    if y=24 then begin
       if x=1 then begin
         y:=3;x:=42;
       end else begin
         gotoxy(1,25);
         enter;
         clrscr;
         gotoxy(1,1);
         write('Folgende Batch-Dateien knnen aufgerufen werden: ');
         y:=3;x:=1;
       end;
    end;
    gotoxy(x,y);
    write(copy(datei[i],1,length(datei[i])-4));
    assign(d,dirverz+'\'+datei[i]);
    reset(d);
    readln(d,zeile);
    readln(d,zeile);
    close(d);
    gotoxy(x+9,y);
    write(copy(zeile,5,30));
  end;
  if x=1 then writeln;
  if x>1 then gotoxy(1,24);
end;


procedure checkpara(par1:string);
var gef:boolean;
begin
  if ((par1='/?') or (par1='?')) then hilfe;
  dirverz:=par1;
  getdir(0,aktverz);
(*$I-*)
  chdir(dirverz);
(*$I+*)
  gef:=ioresult=0;
  if not gef then begin write('Dir nicht vorhanden !!');writeln;halt;end;
  chdir(aktverz);
end;



(* Hauptprogramm *)
begin
  if paramcount=0 then
  begin
    getdir(3,dirverz);
    aktverz:=dirverz;
  end;
  if paramcount>=1 then checkpara(paramstr(1));
  i:=0;
  lesen(dirverz+'\*.bat');
  max:=i;
  sortieren(max,datei,datei);
  ausgeben;
end.
