(*
Zaubert Sterne auf den Bildschirm
<f> Farbe ndern
<+>,<-> Geschwindigkeit ndern
<ESC> Beenden
*)

program stars;
uses graph,crt;
type feld = array [0..5000] of integer;
var i,j,karte,modus,xmax,
    ymax,farbe,starmax,dx,dy:integer;
    speed                   :real;
    ch                      :char;
    x,xx,y,yy               :feld;
    s:string;


procedure loeschen;
begin
  putpixel(x[i]-xx[i],y[i]-yy[i],black);
end;


procedure zeichnen;
begin
  case j of
    0..20: exit;
       21: farbe:=darkgray;
       23: farbe:=lightgray;
       25: farbe:=white;
  end;
  putpixel(x[i],y[i],farbe);
end;


procedure generieren;
begin
  loeschen;
  repeat
    x[i]:=((xmax div 2)-10)+(random(21));
    y[i]:=((ymax div 2)-10)+(random(21));
    xx[i]:=(random(dx))-((dx) div 2);
    yy[i]:=(random(dy))-((dy) div 2);
  until ((xx[i]<>0) and (yy[i]<>0));
end;


procedure intro;
begin
end;


procedure taste;
begin
  ch:=readkey;
  case ch of
    'f','F':farbe:=random(40);
        '+':begin clearviewport;speed:=speed-1;if speed<1 then speed:=1;end;
        '-':begin clearviewport;speed:=speed+1;end;
        'm':begin clearviewport;starmax:=starmax+20;if starmax>4900 then starmax:=4900;end;
        'w':begin clearviewport;starmax:=starmax-20;if starmax<2 then starmax:=2;end;
  end;
  dx:=round(xmax/speed);
  dy:=round(ymax/speed);
  str(speed,s);
  outtextxy(100,100,s);
end;


(* Hauptprogramm *)
begin
  speed:=15;
  starmax:=200;
  karte:=detect;
  modus:=detect;
  initgraph(karte,modus,'c:\tp\tpold');
  setbkcolor(black);
  setcolor(white);
  clearviewport;
  xmax:=getmaxx;
  ymax:=getmaxy;
  dx:=round(xmax/speed);
  dy:=round(ymax/speed);
  for i:=1 to starmax do begin
    generieren;
  end;
  j:=0;
  ch:='l';
  repeat
    for i:=1 to starmax do begin
      x[i]:=x[i]+xx[i];
      y[i]:=y[i]+yy[i];
      loeschen;
      if ((x[i]<=0) or (x[i]>xmax) or (y[i]<=0) or (y[i]>ymax)) then generieren;
      zeichnen;
    end;
    if keypressed then taste;
    if ch=chr(27) then begin closegraph;exit;end;
    j:=j+1;if j=10000 then j:=100;
  until 1=2;
end.
